(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/animations'), require('@angular/router'), require('rxjs/operators'), require('@angular/common'), require('@angular/platform-browser/animations')) :
    typeof define === 'function' && define.amd ? define('a4-modal', ['exports', '@angular/core', '@angular/animations', '@angular/router', 'rxjs/operators', '@angular/common', '@angular/platform-browser/animations'], factory) :
    (global = global || self, factory(global['a4-modal'] = {}, global.ng.core, global.ng.animations, global.ng.router, global.rxjs.operators, global.ng.common, global.ng.platformBrowser.animations));
}(this, function (exports, core, animations, router, operators, common, animations$1) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalComponent = /** @class */ (function () {
        function ModalComponent(resolver, router) {
            this.resolver = resolver;
            this.router = router;
            this.scaling = false;
        }
        /**
         * @return {?}
         */
        ModalComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (!!this.width) {
                this.hostWidth = this.width;
            }
            if (!!this.height) {
                this.hostHeight = this.height;
            }
            /** @type {?} */
            var factory = this.resolver.resolveComponentFactory(this.injectComponent.component);
            this.componentRef = this.viewContainerRef.createComponent(factory);
            if (!!this.injectComponent.inputs) {
                Object.keys(this.injectComponent.inputs)
                    .forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) { return _this.componentRef.instance[key] = _this.injectComponent.inputs[key]; }));
            }
            this.componentRef.instance.modal = this;
            this.scaling = true;
            this.subscription = this.router.events
                .pipe(operators.filter((/**
             * @param {?} p
             * @return {?}
             */
            function (p) { return p instanceof router.NavigationStart; })))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this.componentRef.destroy();
                _this.injectComponent.reject();
            }));
            if (this.showOverlay) {
                this.showOverlay();
            }
        };
        /**
         * @return {?}
         */
        ModalComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.hideOverlay) {
                this.hideOverlay();
            }
            this.subscription.unsubscribe();
        };
        /**
         * @template T
         * @param {?} result
         * @return {?}
         */
        ModalComponent.prototype.close = /**
         * @template T
         * @param {?} result
         * @return {?}
         */
        function (result) {
            this.result = result;
            this.scaling = false;
        };
        /**
         * @param {?} e
         * @return {?}
         */
        ModalComponent.prototype.animationDone = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (!e.toState) {
                this.injectComponent.resolve(this.result);
                this.componentRef.destroy();
            }
        };
        ModalComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line:component-selector
                        selector: 'a4-modal',
                        template: "<ng-template #container></ng-template>",
                        animations: [
                            animations.trigger('scaling', [
                                animations.state('0', animations.style({ transform: 'translate(-50%, -50%) scale(0)' })),
                                animations.state('1', animations.style({ transform: 'translate(-50%, -50%) scale(1)' })),
                                animations.transition(':enter', [animations.style({ transform: 'translate(-50%, -50%) scale(0)' }), animations.animate('250ms ease')]),
                                animations.transition('1 => 0', animations.animate('250ms ease'))
                            ])
                        ],
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: ["\n  :host {\n    display: block;\n    position: fixed;\n    z-index: 1000;\n    background-color: white;\n    left: 50vw;\n    top: 50vh;\n    border: 1px solid rgba(0,0,0,0.1);\n    border-radius: 4px;\n    box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);\n  }\n  "]
                    }] }
        ];
        /** @nocollapse */
        ModalComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: router.Router }
        ]; };
        ModalComponent.propDecorators = {
            injectComponent: [{ type: core.Input }],
            width: [{ type: core.Input }],
            height: [{ type: core.Input }],
            showOverlay: [{ type: core.Input }],
            hideOverlay: [{ type: core.Input }],
            viewContainerRef: [{ type: core.ViewChild, args: ['container', { read: core.ViewContainerRef, static: true },] }],
            scaling: [{ type: core.HostBinding, args: ['@scaling',] }],
            hostWidth: [{ type: core.HostBinding, args: ['style.width',] }],
            hostHeight: [{ type: core.HostBinding, args: ['style.height',] }],
            animationDone: [{ type: core.HostListener, args: ['@scaling.done', ['$event'],] }]
        };
        return ModalComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalService = /** @class */ (function () {
        function ModalService(resolver, applicationRef) {
            this.resolver = resolver;
            this.applicationRef = applicationRef;
        }
        Object.defineProperty(ModalService.prototype, "viewContainerRef", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                /** @type {?} */
                var appInstance = this.applicationRef.components[0].instance;
                if (!appInstance.viewContainerRef) {
                    /** @type {?} */
                    var appName = this.applicationRef.componentTypes[0].name;
                    throw new Error("Missing 'viewContainerRef' declaration in " + appName + " constructor");
                }
                return appInstance.viewContainerRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @template T
         * @param {?} component
         * @param {?=} inputs
         * @param {?=} width
         * @param {?=} height
         * @return {?}
         */
        ModalService.prototype.open = /**
         * @template T
         * @param {?} component
         * @param {?=} inputs
         * @param {?=} width
         * @param {?=} height
         * @return {?}
         */
        function (component, inputs, width, height) {
            var _this = this;
            /** @type {?} */
            var componentRef;
            return new Promise((/**
             * @param {?} mainResolve
             * @param {?} mainReject
             * @return {?}
             */
            function (mainResolve, mainReject) {
                new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        /** @type {?} */
                        var factory = _this.resolver.resolveComponentFactory(ModalComponent);
                        componentRef = _this.viewContainerRef.createComponent(factory);
                        componentRef.instance['injectComponent'] = {
                            component: component, inputs: inputs, resolve: resolve, reject: reject
                        };
                        componentRef.instance.width = width;
                        componentRef.instance.height = height;
                        componentRef.instance.showOverlay = _this.showOverlay;
                        componentRef.instance.hideOverlay = _this.hideOverlay;
                    }), 0);
                })).then((/**
                 * @param {?} result
                 * @return {?}
                 */
                function (result) {
                    componentRef.destroy();
                    mainResolve(result);
                })).catch((/**
                 * @param {?} reason
                 * @return {?}
                 */
                function (reason) {
                    componentRef.destroy();
                    mainReject(reason);
                }));
            }));
        };
        /**
         * @param {?} showOverlay
         * @param {?} hideOverlay
         * @return {?}
         */
        ModalService.prototype.setOverlay = /**
         * @param {?} showOverlay
         * @param {?} hideOverlay
         * @return {?}
         */
        function (showOverlay, hideOverlay) {
            this.showOverlay = showOverlay;
            this.hideOverlay = hideOverlay;
        };
        ModalService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ModalService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef }
        ]; };
        /** @nocollapse */ ModalService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ModalService_Factory() { return new ModalService(core.ɵɵinject(core.ComponentFactoryResolver), core.ɵɵinject(core.ApplicationRef)); }, token: ModalService, providedIn: "root" });
        return ModalService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalModule = /** @class */ (function () {
        function ModalModule() {
        }
        ModalModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            router.RouterModule,
                            animations$1.BrowserAnimationsModule
                        ],
                        declarations: [
                            ModalComponent
                        ],
                        entryComponents: [
                            ModalComponent
                        ],
                        providers: [
                            ModalService
                        ]
                    },] }
        ];
        return ModalModule;
    }());

    exports.ModalComponent = ModalComponent;
    exports.ModalModule = ModalModule;
    exports.ModalService = ModalService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=a4-modal.umd.js.map
