import { Component, ChangeDetectionStrategy, ComponentFactoryResolver, Input, ViewChild, ViewContainerRef, HostBinding, HostListener, Injectable, ApplicationRef, ɵɵdefineInjectable, ɵɵinject, NgModule } from '@angular/core';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { NavigationStart, Router, RouterModule } from '@angular/router';
import { filter } from 'rxjs/operators';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModalComponent = /** @class */ (function () {
    function ModalComponent(resolver, router) {
        this.resolver = resolver;
        this.router = router;
        this.scaling = false;
    }
    /**
     * @return {?}
     */
    ModalComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (!!this.width) {
            this.hostWidth = this.width;
        }
        if (!!this.height) {
            this.hostHeight = this.height;
        }
        /** @type {?} */
        var factory = this.resolver.resolveComponentFactory(this.injectComponent.component);
        this.componentRef = this.viewContainerRef.createComponent(factory);
        if (!!this.injectComponent.inputs) {
            Object.keys(this.injectComponent.inputs)
                .forEach((/**
             * @param {?} key
             * @return {?}
             */
            function (key) { return _this.componentRef.instance[key] = _this.injectComponent.inputs[key]; }));
        }
        this.componentRef.instance.modal = this;
        this.scaling = true;
        this.subscription = this.router.events
            .pipe(filter((/**
         * @param {?} p
         * @return {?}
         */
        function (p) { return p instanceof NavigationStart; })))
            .subscribe((/**
         * @return {?}
         */
        function () {
            _this.componentRef.destroy();
            _this.injectComponent.reject();
        }));
        if (this.showOverlay) {
            this.showOverlay();
        }
    };
    /**
     * @return {?}
     */
    ModalComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.hideOverlay) {
            this.hideOverlay();
        }
        this.subscription.unsubscribe();
    };
    /**
     * @template T
     * @param {?} result
     * @return {?}
     */
    ModalComponent.prototype.close = /**
     * @template T
     * @param {?} result
     * @return {?}
     */
    function (result) {
        this.result = result;
        this.scaling = false;
    };
    /**
     * @param {?} e
     * @return {?}
     */
    ModalComponent.prototype.animationDone = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (!e.toState) {
            this.injectComponent.resolve(this.result);
            this.componentRef.destroy();
        }
    };
    ModalComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'a4-modal',
                    template: "<ng-template #container></ng-template>",
                    animations: [
                        trigger('scaling', [
                            state('0', style({ transform: 'translate(-50%, -50%) scale(0)' })),
                            state('1', style({ transform: 'translate(-50%, -50%) scale(1)' })),
                            transition(':enter', [style({ transform: 'translate(-50%, -50%) scale(0)' }), animate('250ms ease')]),
                            transition('1 => 0', animate('250ms ease'))
                        ])
                    ],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: ["\n  :host {\n    display: block;\n    position: fixed;\n    z-index: 1000;\n    background-color: white;\n    left: 50vw;\n    top: 50vh;\n    border: 1px solid rgba(0,0,0,0.1);\n    border-radius: 4px;\n    box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);\n  }\n  "]
                }] }
    ];
    /** @nocollapse */
    ModalComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: Router }
    ]; };
    ModalComponent.propDecorators = {
        injectComponent: [{ type: Input }],
        width: [{ type: Input }],
        height: [{ type: Input }],
        showOverlay: [{ type: Input }],
        hideOverlay: [{ type: Input }],
        viewContainerRef: [{ type: ViewChild, args: ['container', { read: ViewContainerRef, static: true },] }],
        scaling: [{ type: HostBinding, args: ['@scaling',] }],
        hostWidth: [{ type: HostBinding, args: ['style.width',] }],
        hostHeight: [{ type: HostBinding, args: ['style.height',] }],
        animationDone: [{ type: HostListener, args: ['@scaling.done', ['$event'],] }]
    };
    return ModalComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModalService = /** @class */ (function () {
    function ModalService(resolver, applicationRef) {
        this.resolver = resolver;
        this.applicationRef = applicationRef;
    }
    Object.defineProperty(ModalService.prototype, "viewContainerRef", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var appInstance = this.applicationRef.components[0].instance;
            if (!appInstance.viewContainerRef) {
                /** @type {?} */
                var appName = this.applicationRef.componentTypes[0].name;
                throw new Error("Missing 'viewContainerRef' declaration in " + appName + " constructor");
            }
            return appInstance.viewContainerRef;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @template T
     * @param {?} component
     * @param {?=} inputs
     * @param {?=} width
     * @param {?=} height
     * @return {?}
     */
    ModalService.prototype.open = /**
     * @template T
     * @param {?} component
     * @param {?=} inputs
     * @param {?=} width
     * @param {?=} height
     * @return {?}
     */
    function (component, inputs, width, height) {
        var _this = this;
        /** @type {?} */
        var componentRef;
        return new Promise((/**
         * @param {?} mainResolve
         * @param {?} mainReject
         * @return {?}
         */
        function (mainResolve, mainReject) {
            new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var factory = _this.resolver.resolveComponentFactory(ModalComponent);
                    componentRef = _this.viewContainerRef.createComponent(factory);
                    componentRef.instance['injectComponent'] = {
                        component: component, inputs: inputs, resolve: resolve, reject: reject
                    };
                    componentRef.instance.width = width;
                    componentRef.instance.height = height;
                    componentRef.instance.showOverlay = _this.showOverlay;
                    componentRef.instance.hideOverlay = _this.hideOverlay;
                }), 0);
            })).then((/**
             * @param {?} result
             * @return {?}
             */
            function (result) {
                componentRef.destroy();
                mainResolve(result);
            })).catch((/**
             * @param {?} reason
             * @return {?}
             */
            function (reason) {
                componentRef.destroy();
                mainReject(reason);
            }));
        }));
    };
    /**
     * @param {?} showOverlay
     * @param {?} hideOverlay
     * @return {?}
     */
    ModalService.prototype.setOverlay = /**
     * @param {?} showOverlay
     * @param {?} hideOverlay
     * @return {?}
     */
    function (showOverlay, hideOverlay) {
        this.showOverlay = showOverlay;
        this.hideOverlay = hideOverlay;
    };
    ModalService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ModalService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef }
    ]; };
    /** @nocollapse */ ModalService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ModalService_Factory() { return new ModalService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef)); }, token: ModalService, providedIn: "root" });
    return ModalService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModalModule = /** @class */ (function () {
    function ModalModule() {
    }
    ModalModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        RouterModule,
                        BrowserAnimationsModule
                    ],
                    declarations: [
                        ModalComponent
                    ],
                    entryComponents: [
                        ModalComponent
                    ],
                    providers: [
                        ModalService
                    ]
                },] }
    ];
    return ModalModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ModalComponent, ModalModule, ModalService };
//# sourceMappingURL=a4-modal.js.map
